/*
 * dhry.h
 *
 *  Created on: 20/05/2011
 *      Author: anderson
 *      e-mail: alsm4@cin.ufpe.br
 */

#ifndef DHRY_H_
#define DHRY_H_

/*Definies do compilador*/
#ifndef TIME
#define TIMES
#endif
/* Utilize a diretiva de compilao times(2)    */
/* se no for explicitamente definido, porm os atuais compiladores utilizam
 * TIME         */
#ifdef TIMES
#include <sys/types.h>
#include <sys/time.h>
#endif

#define	Mic_secs_Per_Second	1000000.0
/* Berkeley UNIX C retorna o tempo de processo em segundos/HZ */

#ifdef NOSTRUCTASSIGN
#define structassign(d,s)      memcpy(&(d), &(s), sizeof(d))
#else
#define structassign(d,s)      d = s
#endif

#ifdef  NOENUM
#define Ident_1 0
#define Ident_2 1
#define Ident_3 2
#define Ident_4 3
#define Ident_5 4
	typedef int	Enumeration;
#else
	typedef	enum	{Ident_1, Ident_2, Ident_3, Ident_4, Ident_5} Enumeration;
#endif
/* para boleanos e tipos enumeration types em Ada e Pascal */

/* Definies gerais: */

#include <stdio.h>
#include <string.h> // para strcpy, strcmp
#include <time.h> //para __DATA__ __HORA__
#include <dos.h>

#define Null 0 // valor para um ponteiro Null
#define true  1
#define false 0

typedef int One_Thirty;
typedef int One_Fifty;
typedef char Capital_Letter;
typedef int Boolean;
typedef char Str_30 [31];
typedef int Arr_1_Dim [50];
typedef int Arr_2_Dim [50] [50];

typedef struct record
{
	struct record *Ptr_Comp;
    Enumeration    Discr;
    union {
    	struct {
    		Enumeration Enum_Comp;
            int Int_Comp;
            char Str_Comp [31];
        } var_1;
        struct {
        	Enumeration E_Comp_2;
            char Str_2_Comp [31];
        } var_2;
        struct {
             char Ch_1_Comp;
             char Ch_2_Comp;
        } var_3;
    } variant;
} Rec_Type, *Rec_Pointer;

#endif /* DHRY_H_ */
